{
  self,
  ...
}:

{
  imports = [
    ../nix-os/core.nix
    ../nix-os/core-desktop.nix
    ../nix-os/account.nix
    ../nix-os/adb.nix
    ../nix-os/locale.nix
    ../nix-os/shell.nix
    ../nix-os/gnupg.nix
    ../nix-os/polkit/network.nix

    ../nix-os/desktopManagers/cosmic.nix
    ../nix-os/displayManagers/cosmic-greeter.nix
    ../nix-os/udev.nix
  ];

  config = {
    boot.loader.systemd-boot.enable = true;
    boot.loader.efi.canTouchEfiVariables = true;

    networking.hostName = "wroclaw-hp";
    networking.networkmanager.enable = true;
    networking.firewall.enable = true;
    hardware.sensor.iio.enable = true;

    nixpkgs.overlays = [
      self.overlays.cosmicPackages
    ];

    networking.firewall.allowedTCPPortRanges = [
      # KDE Connect
      rec { from = 1714; to = from + 50; }
    ];

    networking.firewall.allowedUDPPortRanges = [
      # KDE Connect
      rec { from = 1714; to = from + 50; }
    ];

    services.logind.extraConfig = ''
      HandlePowerKey=suspend
      HandlePowerKeyLongPress=poweroff
      HandleSuspendKey=suspend-then-hibernate
      HandleSuspendKeyLongPress=hibernate
      HandleLidSwitch=lock
      HandleLidSwitchDocked=ignore
      HandleLidSwitchExternalPower=lock
    '';

    system.stateVersion = "23.11";
  };
}

