{ lib, modulesPath, ... }:

{
  imports = [
    "${modulesPath}/virtualisation/qemu-vm.nix"
    ../nix-os/account.nix
    ../nix-os/core.nix
    ../nix-os/core-desktop.nix
    ../nix-os/locale.nix
    ../nix-os/polkit/disable-shutdown.nix
    ../nix-os/shell.nix
    ../nix-os/udev.nix
  ];

  config = {
    services.syncthing.enable = lib.mkForce false;
    virtualisation = {
      memorySize = 4096;
    };
    virtualisation.forwardPorts = [
      { from = "host"; host.port = 2222; guest.port = 22; }
    ];
  };
}
