let self = {
  lock ? import ./lock.nix
, lib ? import "${(self {}).nixpkgs}/lib"
}:

{
  inherit lock;
  nixos-vscode-server = builtins.fetchTarball {
    name = "nixos-vscode-server";
    url = "https://github.com/nix-community/nixos-vscode-server/archive/${lock.nixos-vscode-server.revision}.tar.gz";
    sha256 = "${lock.nixos-vscode-server.sha256}";
  };
  nixpkgs = builtins.fetchTarball {
    name = "nixpkgs";
    url = "https://github.com/NixOS/nixpkgs/archive/${lock.nixpkgs.revision}.tar.gz";
    sha256 = "${lock.nixpkgs.sha256}";
  };
  nixpkgs-unstable = builtins.fetchTarball {
    name = "nixpkgs-unstable";
    url = "https://github.com/NixOS/nixpkgs/archive/${lock.nixpkgs-unstable.revision}.tar.gz";
    sha256 = "${lock.nixpkgs-unstable.sha256}";
  };
  cosmic-modules = builtins.fetchTarball {
    name = "cosmic-modules";
    url = "https://github.com/lilyinstarlight/nixos-cosmic/archive/${lock.cosmic-modules.revision}.tar.gz";
    sha256 = "${lock.cosmic-modules.sha256}";
  };
};
in self
