{ config, lib, pkgs, unstablePkgs, ... }:

{
  imports = [
    ./unstable-packages.nix
  ];
  users.users.wroclaw = {
    isNormalUser = true;
    description = "Rafał";
    group = "wroclaw";
    extraGroups = [
      "users"
      "wheel"
    ] ++ lib.optional config.programs.adb.enable "adbusers";
    linger = true;
    initialPassword = "nixos";
    packages = with pkgs; [
      firefox
      (vivaldi.override {
        proprietaryCodecs = true;
        commandLineArgs = [ "--ozone-platform=wayland" ];
      })
      vesktop
      unstablePkgs.vscode
      gimp
      inkscape
      jitsi-meet-electron
      krita
      telegram-desktop
      unstablePkgs.zettlr
    ];
  };
  users.groups.wroclaw.gid = 1000;

  programs.steam = {
    enable = true;
    remotePlay.openFirewall = true;
  };

  services.syncthing = {
    enable = true;
    user = "wroclaw";
    group = "wroclaw";
    dataDir = "/home/wroclaw";
    configDir = "/home/wroclaw/.config/syncthing";
  };
}
